///////////////////////////////////////////////////////////////////////////////
// The carousel class gets shows the choices for Mippin

// Constructor.
function Carousel(margs){
	this.margs = margs
}

Carousel.prototype.init = function(){
	var self = this;
	var margs = this.margs;
	this.container = document.getElementById(margs.uuid);
	this.offset;
	var status;
	
	this.contentPane = document.getElementById(margs.uuid + "-content-pane");
	this.items;
	var index = 0;
	this.opacitysetting = 0.1;
	this.fadetimer1;
	this.fadeInterval = 100;
	
	
	this.degree = 0;
	
	this.padding = 20;
	
	this.yRadius = 10;
	
	this.xRadius = (screenWidth / 2) - this.padding;
	this.centerX = (screenWidth / 2);

	this.centerY = 85;
	
	this.iWidth = 67;
	this.iHeight = 95;
	
	this.gap = 0;
	var speed = 'fast';
	this.delay = 0;
	this.increment = 13;
	this.selected = -1;
	this.animate = true;
	this.processing = false;
	this.faderunning = false;
	this.showing = false;
	
	if (margs.args) {
	
		if (margs.args.padding) {
			this.padding = margs.args.padding;
			if (!margs.args.xRadius) 
				this.xRadius = (screenWidth / 2) - this.padding;
		}
		if (margs.args.centerX) {
			this.centerX = margs.args.centerX;
		}
		if (margs.args.centerY) {
			this.centerY = margs.args.centerY;
		}
		if (margs.args.xRadius) {
			this.xRadius = margs.args.xRadius;
		}
		if (margs.args.yRadius) {
			this.yRadius = margs.args.yRadius;
		}
		if (margs.args.xRadius) {
			this.xRadius = margs.args.xRadius;
		}
		if (margs.args.speed) {
			speed = margs.args.speed;
		}
		if (margs.args.iHeight) {
			this.iHeight = margs.args.iHeight;
		}
		if (margs.args.iWidth) {
			this.iWidth = margs.args.iWidth;
		}
	}
	
	this.range = Math.round(this.increment / 2) + 1;
	// speeds set for N95
	this.increment = 13;
	this.delay = 0;
	
	
	if (typeof margs.value != 'undefined') {
		this.items = margs.value;
		self.loadImages();
	}
	self.hideBut();
	
}    

Carousel.prototype.setOpacity=function(opacity, id) {
      var target = document.getElementById(id);
      if (typeof target.style.filter != 'undefined') {
          target.style.filter = "alpha(opacity:" + (opacity*100) + ")";
      } else {
          target.style.opacity = opacity;
		  if (opacity==0) {
		  	target.style.display= 'none';
		  }
		  else {
		  	target.style.display= 'block';
		  }
      }
  }
    
Carousel.prototype.loadLink=function(_l) {
	var self = this;
	
      if (this.selected != _l) {
        var _degree = 0;
        if (this.degree + this.items[_l].degree > 360) _degree = (360 - (this.degree + this.items[_l].degree)) * -1;
        else _degree =  this.degree + this.items[_l].degree;          
        if (_degree > 0 && _degree < 180) {
              self.getPrevious();
   	} else {
              self.getNext();
      	}
      }
  }
  
Carousel.prototype.getPosition=function(_e) {
      var pX = 0;        
      var pY = 0;
      if (_e.offsetParent) {
          pX = _e.offsetLeft;        
          pY = _e.offsetTop;
      }
      while (_e.offsetParent) {
          _e = _e.offsetParent;
          pX += _e.offsetLeft;          
          pY += _e.offsetTop;
          
      }  
      return {x: pX, y: pY};
  } 

  
Carousel.prototype.findPos=function(obj) {
	var curleft = curtop = 0;
	if (obj.offsetParent) {
		curleft = obj.offsetLeft
		curtop = obj.offsetTop
		while (obj = obj.offsetParent) {
			curleft += obj.offsetLeft
			curtop += obj.offsetTop
		}
	}
	return { x: curleft, y: curtop };
}
  

Carousel.prototype.resize=function() {
	this.xRadius = (screenWidth / 2) - this.padding;
	this.centerX = (screenWidth / 2);

      this.offset = this.getPosition(this.container);      
      var l = this.offset.x;
      this.reposition();
 }
 

Carousel.prototype.loadText=function(){
	var self = this;

      for (var _l=0; _l < this.items.length; _l++) {
	  	if (this.items[_l].use==0) continue;
          this.items[_l].link = document.createElement('div');
          this.items[_l].link.innerHTML = this.items[_l].title;

         this.contentPane.appendChild(this.items[_l].link);
      }
      self.resize();
      
  }



Carousel.prototype.loadImages=function(){
	var self = this;

      for (var _l=0; _l < this.items.length; _l++) {
	  	if (this.items[_l].use==0) continue;
          this.items[_l].link = document.createElement('div');
          this.items[_l].image = document.createElement("img");
          this.items[_l].image.style.visibility = 'hidden';
          this.items[_l].image.style.position = "absolute";
          this.items[_l].image.src = this.items[_l].imgSrc;
          this.items[_l].originalWidth = this.items[_l].image.width;
          this.items[_l].originalHeight = this.items[_l].image.height;
          this.items[_l].image.style.height = this.iWidth + 'px';
          this.items[_l].image.style.width = this.iHeight + 'px';
          this.items[_l].image.border = '0px';          
          this.items[_l].image.style.zIndex =  _l;
          this.items[_l].image.id = _l;
          this.items[_l].image.style.cursor = "pointer";
         this.items[_l].degree = _l * (360 / this.items.length);
         this.items[_l].link.appendChild(this.items[_l].image);

         this.contentPane.appendChild(this.items[_l].link);
      }
      this.gap = (360 / this.items.length);
      self.resize();
      for (var _l=0; _l < this.items.length; _l++) {
          this.items[_l].image.style.visibility = 'visible'; 
      }
      self.getNext();
      
  }
  
Carousel.prototype.scaleImage=function(_i, percentage) {
      this.items[_i].image.style.width = (this.iWidth * percentage) + "px";
      this.items[_i].image.style.height = (this.iHeight * percentage) + "px";
  }
  
Carousel.prototype.processImage=function(_i, deg) {
      // if between 0 / 180 we should be shrinking
      var size = 1;      
      if (deg >= 0 && deg < 180) {
         size = (180 - deg)/180;

      // if between 180 / 359 we should be growing
      } else if (deg >= 180 && deg <= 360) {
          size = (deg-180)/180;
      }
      this.scaleImage(_i, size);
      this.items[_i].image.style.zIndex = Math.round(size * 100);
  }
  
Carousel.prototype.getNext=function() {
	  var self = this;
	  
	  if (!this.faderunning) {
	  	this.opacitysetting = 0.1;
		showCarousel();
	  	self.fadeUp();
	  }

      if (!this.processing) {
          this.processing = true;
          self.doAnimation(true);
      }

  }
  
  
Carousel.prototype.getPrevious=function() {
	  var self = this;

	  if (!this.faderunning) {
	  	this.opacitysetting = 0.1;
		showCarousel();
	  	self.fadeUp();
	  }
      if (!this.processing) {
          this.processing = true;
          self.doAnimation(false);
      }
	  //fadetimer1=setInterval("fadeDown()",100);
  }
  
Carousel.prototype.reposition=function() {
	var self = this;

      for (var _l = 0; _l < this.items.length; _l++) {
        var _degree = 0;
        if (this.degree + this.items[_l].degree > 360) _degree = (360 - (this.degree + this.items[_l].degree)) * -1;
        else _degree =  this.degree + this.items[_l].degree;
        var pt = this.getElipticalPoint(_degree);     	
        this.items[_l].image.style.top = pt.y  + this.offset.y +  "px";
        this.items[_l].image.style.left = pt.x - (this.items[_l].image.width / 2) + this.offset.x + "px";         	
		self.processImage(_l, _degree);        		
      }
  }
  
Carousel.prototype.doAnimation=function(forward) {
	var self = this;

    if (!this.animate && !this.processing) return;
    var found = false;
	self.hideAction();

    
    for (var _l = 0; _l < this.items.length; _l++) {
        var _degree = 0;
        if (this.degree + this.items[_l].degree > 360) _degree = (360 - (this.degree + this.items[_l].degree)) * -1;
        else _degree =  this.degree + this.items[_l].degree;
        if (forward && this.degree >= 360) {
            this.degree = 0;
      	} else if (!forward &&  this.degree < 0) {
            this.degree = 360;
      	}
  
        if (_degree > 360 - this.range ||
            _degree < this.range) {
            this.items[_l].selected = true;
            if (this.selected != _l){
                this.selected = _l;
                found = true;
                this.processing = false;
				self.showAction();
				//self.waitThenFade();
      	        break;
      	    }
        }
        var pt = this.getElipticalPoint(_degree);     	
        this.items[_l].image.style.top = pt.y  + this.offset.y +  "px";
 
        this.items[_l].image.style.left = pt.x - (this.items[_l].image.width / 2) + this.offset.x + "px";         	
        this.processImage(_l, _degree);
        this.items[_l].link.href = '#';
        this.items[_l].link.target = "_self";
             		
      }
      if (found == true) {
          self.reposition();

          // center the selected div
         this.items[this.selected].image.style.left = (this.container.clientWidth / 2) - (this.items[this.selected].image.width / 2) + this.offset.x + "px"; 


          this.items[this.selected].image.style.zIndex = 400;
          var target = "";
          if (this.items[this.selected].target) target = " target='" + this.items[this.selected].target + "'";
		  self.showBut();
          this.items[this.selected].link.href = this.items[this.selected].href;
          if (this.items[this.selected].target) this.items[this.selected].link.target = this.items[this.selected].target;
          if (this.items.length == 1) this.selected = -1;
      } else {
        if (forward) this.degree = this.degree + this.increment;
        else this.degree = this.degree - this.increment;
        if (this.animate && this.processing) setTimeout(function(){self.doAnimation(forward)}, this.delay);
      }      
	  
   }
   

Carousel.prototype.clearSelected=function() {
       for (var _l = 0; _l < this.items.length; _l++) {
           this.items[_l].selected = false;
       } 
   }

Carousel.prototype.getElipticalPoint=function(_d) {
      var rad = _d * (Math.PI / 180);
      var _x = this.centerX + this.xRadius * Math.sin(rad);
      var _y = this.centerY + this.yRadius * Math.cos(rad);
      return {x : _x, y : _y};
  }

Carousel.prototype.fadeDown=function(type){
       
 	var self = this;
        
    //  self.setOpacity(this.opacitysetting, this.margs.uuid);
        
    //  this.opacitysetting -= 0.9;
    //  if (this.opacitysetting > 0 ) {
	//	  	setTimeout('carousel.fadeDown()',this.fadeInterval);
    //  }
	//  else {
	 	  this.opacitysetting=0;
	      self.setOpacity(this.opacitysetting, this.margs.uuid);
		  this.faderunning = false;
		  this.showing = false;
		  mode=0;
		  if (running) {
			stopRunning();
		  }
		  setTitle();
		  // hide action button
		  self.hideBut();
		var listViewId = document.getElementById("ListViewMippinId");
		if (listViewId) {
			listViewId.style.display = "block";
		}

	//  }
  }

  
Carousel.prototype.fadeUp=function(){
        
 	  var self = this;
	  this.faderunning=true;        
    //  self.setOpacity(this.opacitysetting, this.margs.uuid);
        
    //  this.opacitysetting += 0.9;
    //  if (this.opacitysetting <= 1) {
	//  	setTimeout('carousel.fadeUp()', this.fadeInterval);
	//  }
	//  else {
	  	this.faderunning = false;
		this.showing = true;
	 	this.opacitysetting=1;
	    self.setOpacity(this.opacitysetting, this.margs.uuid);
		var listViewId = document.getElementById("ListViewMippinId");
		if (!listViewId) return;
		listViewId.style.display = "none";
		
		
	//  }
        
  }
  
Carousel.prototype.waitThenFade=function(type){
    
 	var self = this;
	self.hideBut();    
	this.opacitysetting=1.0;
	setTimeout('carousel.fadeDown()',3000);
        
  }
  
Carousel.prototype.hideBut = function(){
 	var self = this;
    var gobut = document.getElementById("gobutton");
	var act = document.getElementById("actionbutton");
	act.style.display="none";
	gobut.style.display="none";
	var actt = document.getElementById("actiontext");
	actt.style.display="none";
} 

Carousel.prototype.showBut = function(){
 	var self = this;
    var gobut = document.getElementById("gobutton");
	var act = document.getElementById("actionbutton");
	act.style.display="block";
	gobut.style.display="block";
	var actt = document.getElementById("actiontext");
	actt.style.display="block";
}

Carousel.prototype.hideAction = function(){
	var act = document.getElementById("actionbutton");
	act.style.display="none";
	var actt = document.getElementById("actiontext");
	actt.style.display="none";
}

Carousel.prototype.showAction = function(){
	var act = document.getElementById("actionbutton");
	act.style.display="block";
	var actt = document.getElementById("actiontext");
	actt.style.display="block";
	actt.innerHTML=carousel.items[carousel.selected].title;
}

